#ifndef SRC_HDF_ITERATION_WRITER_HH
#define SRC_HDF_ITERATION_WRITER_HH

#include <dune/fufem/hdf5/hdf5-sequence-io.hh>

#include "../adaptivetimestepper.hh"

class IterationWriter {
public:
  IterationWriter(HDF5Grouplike &file);

  void write(size_t timeStep, IterationRegister const &iterationCount);

private:
  HDF5Group group_;
  HDF5Group fpiSubGroup_;
  HDF5Group mgSubGroup_;

  HDF5SequenceIO<0, size_t> finalMGIterationWriter_;
  HDF5SequenceIO<0, size_t> finalFPIIterationWriter_;
  HDF5SequenceIO<0, size_t> totalMGIterationWriter_;
  HDF5SequenceIO<0, size_t> totalFPIIterationWriter_;
};
#endif
